<template>
  <div class="app-container">
    <div class="filter-container">
      <el-input v-model="qrcodes.numberQrcodes" :placeholder="$t('table.numberQrcodes')" style="width: 200px;" class="filter-item" @keyup.enter.native="handleFilter" />
      <el-button class="filter-item" type="primary" icon="el-icon-plus" @click="createQrcodes">
        {{ $t('table.createQrcodes') }}
      </el-button>
      <el-button class="filter-item" type="primary" icon="el-icon-search" @click="generateReport">
        {{ $t('table.pdf') }}
      </el-button>
    </div>
    <el-table v-loading="listLoading" :data="list" border fit highlight-current-row style="width: 100%">
      <el-table-column align="center" :label="$t('table.code')">
        <template slot-scope="scope">
          <span>{{ scope.row.id }}</span>
        </template>
      </el-table-column>
      <el-table-column align="center" :label="$t('route.qrcodes')" style="text-align: center !important;">
        <template slot-scope="scope">
          <qrcode :value="scope.row.id" :options="{ width: 200 }">&nbsp;</qrcode>
        </template>
      </el-table-column>

    </el-table>
    <vue-html2pdf
      ref="html2Pdf"
      :show-layout="false"
      :enable-download="true"
      :preview-modal="true"
      :paginate-elements-by-height="1400"
      filename="qr-codes"
      :pdf-quality="2"
      pdf-format="a4"
      pdf-orientation="landscape"
      pdf-content-width="1000px"
    >
      <section slot="pdf-content">
        <el-table v-loading="listLoading" :data="list" border fit highlight-current-row style="width: 100%">
          <el-table-column align="center" :label="$t('table.code')">
            <template slot-scope="scope">
              <span>{{ scope.row.id }}</span>
            </template>
          </el-table-column>
          <el-table-column align="center" :label="$t('route.qrcodes')" style="text-align: center !important;">
            <template slot-scope="scope">
              <qrcode :value="scope.row.id" :options="{ width: 50 }">&nbsp;</qrcode>
              <qrcode :value="scope.row.id" :options="{ width: 50 }">&nbsp;</qrcode>
            </template>
          </el-table-column>

        </el-table>
      </section>
    </vue-html2pdf>

  </div>
</template>

<script>
import Vue from 'vue';
import Bani from '@/api/bani';
const baniResource = new Bani('bani');
import 'vue-select/src/scss/vue-select.scss';
import VueQrcode from '@chenfengyuan/vue-qrcode';
import VueHtml2pdf from 'vue-html2pdf';

// import i18n from '@/lang';
Vue.component(VueQrcode.name, VueQrcode);

export default {
  name: 'BaniList',
  components: { VueHtml2pdf },
  filters: {
    statusFilter(status) {
      const statusMap = {
        published: 'success',
        draft: 'info',
        deleted: 'danger',
      };
      return statusMap[status];
    },
  },
  data() {
    return {
      list: null,
      total: 0,
      qrcodes: {
        numberQrcodes: 1,
      },
      manage: {},
      listLoading: false,
      query: {
        page: 1,
        limit: 15,
        title: '',
        role: '',
      },
      options: [],
    };
  },
  created() {},
  methods: {
    generateReport() {
      this.$refs.html2Pdf.generatePdf();
    },
    createQrcodes() {
      this.listLoading = true;
      baniResource.createQrcodes(this.qrcodes).then(result => {
        this.list = result.codes;
        this.listLoading = false;
      });
    },
    handleFilter() {
      this.query.page = 1;
      this.getList();
    },
    onSearch(search, loading) {
      fetch(
        '/api/searchUsers?q=' + search
      ).then(res => {
        res.json().then(json => (this.options = json.items));
        console.log(this.options);
        loading(false);
      });
    },
  },
};
</script>
